/*
 *  $Id: mpi_errno.h,v 1.4 1994/01/26 00:13:15 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/* error codes for MPI programs */

#ifndef _MPI_ERRNO
#define _MPI_ERRNO

/* error return codes */
#define MPI_EXAUSTED         1      /* ?? */
#define MPI_INVALID_TAG      2      /* ?? */
#define MPI_ERR_COMM_NULL    3      /* NULL communicator argument passed to function */
#define MPI_ERR_COMM_INTER   4      /* Intercommunicator is not allowed in function */
#define MPI_ERR_ARG          5      /* Invalid argument */
#define MPI_ERR_BUFFER       6      /* Invalid buffer pointer */
#define MPI_ERR_COUNT        7      /* Invalid count argument */
#define MPI_ERR_TYPE         8      /* Invalid datatype argument */
#define MPI_ERR_ROOT         9      /* Invalid root */
#define MPI_ERR_OP          10      /* Invalid operation */
#define MPI_ERR_ERRORCODE   11      /* Invalid error code */
#define MPI_ERR_GROUP_NULL  12      /* Null group passed to function */
#define MPI_ERR_RANK        13      /* Invalid rank */
#define MPI_ERR_TOPOLOGY    14      /* Invalid topology */
#define MPI_ERR_DIMS        15      /* Illegal dimension argument */
#define MPI_ERR_NULL        16      /* Null parameter */
#define MPI_ERR_UNKNOWN     17      /* Unknown error */
#define MPI_ERR_LASTCODE    18      /* Last error code -- always at end */
#endif /* _MPI_ERRNO */

