/*
 *  $Id: allreduce.c,v 1.7 1994/01/19 21:45:44 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: allreduce.c,v 1.7 1994/01/19 21:45:44 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_Allreduce - 

@*/
MPI_Allreduce ( sendbuf, recvbuf, count, datatype, op, comm )
void             *sendbuf;
void             *recvbuf;
int               count;
MPI_Datatype      datatype;
void            (*op)();
MPI_Comm          comm;
{
  int errno = MPI_SUCCESS;

  /* Check for invalid arguments */
  if ( ( (comm            == (MPI_Comm)0) && (errno = MPI_ERR_COMM_NULL) ) ||
       ( (comm->comm_type == MPIR_INTER)  && (errno = MPI_ERR_COMM_INTER) ) )
    return (errno); 
  
  /* Reduce to 0, then bcast */
  MPI_Reduce ( sendbuf, recvbuf, count, datatype, op, 0, comm );
  MPI_Bcast  ( recvbuf, count, datatype, 0, comm );

  return (errno);
}
