/* reduce.c */
/* Fortran interface file for sun4 */
#include "mpi.h"

int mpi_allreduce_ ( sendbuf, recvbuf, count, datatype, op, comm)
void             *sendbuf;
void             *recvbuf;
int               *count;
int            *datatype;
int                *op;
int                *comm;
{
    void (*r)() = 0;

    MPI_Comm     comm2;
    MPI_Datatype datatype2;
    if (*comm == 0) comm2 = MPI_COMM_WORLD;
    else            comm2 = *(MPI_Comm *)comm;
    if (*datatype == 0) datatype2 = MPI_DOUBLE;
    else                datatype2 = 0;

    /* Get the operation from the op */
    switch (*op) {
	case 0:  r = MPI_SUM;  break;
	case 1:  r = MPI_MAX;  break;
	case 2:  r = MPI_MIN;  break;
	case 3:  r = MPI_SUM;  break;
	case 4:  r = MPI_PROD; break;
	case 5:  r = MPI_LAND; break;
	case 6:  r = MPI_BAND; break;
	case 7:  r = MPI_LOR;  break;
	case 8:  r = MPI_BOR;  break;
	case 9:  r = MPI_LXOR; break;
	case 10: r = MPI_BXOR; break;
	}
    if (!r) {
	fprintf( stderr, "Invalid MPI_reduce operation (Fortran)\n" );
	return -1;
	}
    return MPI_Allreduce(sendbuf,recvbuf,*count,datatype2,r,comm2);
}
