/*
 *  $Id: comm_size.c,v 1.5 1994/01/28 17:31:49 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/*@

MPI_Comm_size - determine the size of the group associated with a communictor

@*/

#include <mpi.h>


int MPI_Comm_size ( comm, size )
MPI_Comm comm;
int *size;
{
  /* Check for bad arguments */
  if ( (comm != (MPI_Comm)0) && (comm->group != (MPI_Group)0) ) 
    (*size) = comm->group->np;
  else
    (*size) = 0;
  return (MPI_SUCCESS);
}

