/*
 *  $Id: waitall.c,v 1.10 1994/01/31 23:38:06 lusk Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: waitall.c,v 1.10 1994/01/31 23:38:06 lusk Exp $";
#endif /* lint */
#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Waitall - 
@*/
int MPI_Waitall(count, handles, statuses )
int              count;
MPI_Comm_request handles[];
MPI_Status       statuses[];
{
    int i;
    MPIR_BOOL completed;
    
    for (i = 0; i < count; i++)
    {
        /* Skip over null handles.  We need this for handles generated
           when MPI_PROCNULL is the source or destination of an operation */
        if (!handles[i]) continue;
        /* This should really use complete_send and complete_recv */
        completed = handles[i]->chandle.completed;

	while ( completed == NO ) {
	    MPID_check_device( 1 );
	    completed = handles[i]->chandle.completed;
	    }

	if ( handles[i]->type == MPIR_RECV )
	{
	    MPID_complete_recv( &handles[i]->rhandle );

	    statuses[i].source = handles[i]->rhandle.source;
	    statuses[i].tag    = handles[i]->rhandle.tag;
	    statuses[i].count  = handles[i]->rhandle.actcount;  
	}
	else
	    MPID_complete_send( &handles[i]->shandle, &(statuses[i]) );

	MPI_Commreq_free( handles[i] ); /* Spec requires, but... */
	handles[i]    = NULL;
    }
    return MPI_OK;
}
